"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Store = void 0;
class Store {
    constructor() {
        this.store = {};
    }
    static getInstance() {
        if (!Store.instance) {
            Store.instance = new Store();
        }
        return Store.instance;
    }
    static hash(str) {
        let hash = 0;
        for (let i = 0, len = str.length; i < len; i++) {
            let chr = str.charCodeAt(i);
            hash = (hash << 5) - hash + chr;
            hash |= 0; // Convert to 32bit integer
        }
        return hash;
    }
    set(entity, property, received) {
        const hash = Store.hash(`${entity}.${property}.${received}`);
        if (this.has(hash)) {
            this.store[hash]++;
        }
        else {
            this.store[hash] = 1;
        }
    }
    get(entity, property, received) {
        var _a;
        const hash = Store.hash(`${entity}.${property}.${received}`);
        return (_a = this.store) === null || _a === void 0 ? void 0 : _a[hash];
    }
    has(hash) {
        return this.store[hash] !== undefined;
    }
    clear() {
        this.store = {};
    }
}
exports.Store = Store;
