"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.t = void 0;
function optional(arg) {
    return t(Object.assign(Object.assign({}, arg), { value: arg.value + " | " + "undefined", isOptional: true }));
}
function nullable(arg) {
    return t(Object.assign(Object.assign({}, arg), { value: arg.value + " | " + "null", isNullable: true }));
}
function withBaseProps(arg) {
    const next = Object.assign(Object.assign({}, arg), { isNullable: false, isOptional: false, optional: () => optional(Object.assign({}, next)), nullable: () => nullable(Object.assign({}, next)) });
    return next;
}
function union(...args) {
    const next = {
        value: args
            .map((arg) => (typeof arg === "function" ? arg.name : arg.value))
            .join(" | "),
        entities: args.reduce((acc, cur) => {
            if (typeof cur === "function") {
                return Object.assign(Object.assign({}, acc), { [cur.name]: cur });
            }
            return Object.assign(Object.assign({}, acc), cur.entities);
        }, {}),
        _proto_: "union",
    };
    return withBaseProps(next);
}
function array(arg) {
    const next = {
        value: `Array<${typeof arg === "function" ? arg.name : arg.value}>`,
        entities: typeof arg === "function"
            ? { [arg.name]: arg }
            : Object.assign({}, arg.entities),
        _proto_: "array",
    };
    return withBaseProps(next);
}
function record(key, value) {
    const next = {
        value: `Record<${key.name}, ${typeof value === "function" ? value.name : value.value}>`,
        entities: typeof value === "function"
            ? { [value.name]: value }
            : Object.assign({}, value.entities),
        _proto_: "record",
    };
    return withBaseProps(next);
}
function custom(callbackfn) {
    return withBaseProps({
        value: "custom",
        mapper: callbackfn,
        _proto_: "custom",
    });
}
function t(arg) {
    if (typeof arg === "object") {
        const next = Object.assign({}, arg);
        const res = Object.assign(Object.assign({}, next), { optional: !next.isOptional ? () => optional(res) : () => res, nullable: !next.isNullable ? () => nullable(res) : () => res });
        return res;
    }
    if (typeof arg === "function") {
        const next = {
            value: arg.name,
            entities: { [arg.name]: arg },
            _proto_: "any",
        };
        return withBaseProps(next);
    }
}
exports.t = t;
t.union = union;
t.array = array;
t.record = record;
t.custom = custom;
