export declare type EntityConstructor<T = unknown> = Function & {
    of: (data: Partial<T>) => T;
    types: Record<string, T>;
};
export declare type Entity<T = unknown> = {
    of: (data: Partial<T>) => T;
} & {
    new (...args: any[]): {};
};
export declare type ParseMeta = {
    key: string;
    owner: string;
};
export declare type T = {
    value: string;
    isOptional: boolean;
    isNullable: boolean;
    entities?: Record<string, Function | EntityConstructor<T>>;
    optional: () => T;
    nullable: () => T;
    mapper?: (value: any) => any;
};
export declare type TRecord = T & {
    _proto_: "record";
};
export declare type TArray = T & {
    _proto_: "array";
};
export declare type TUnion = T & {
    _proto_: "union";
};
export declare type TCustom = T & {
    _proto_: "custom";
};
export declare type TAny = T & {
    _proto_: "any";
};
