"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.clone = exports.capitalize = void 0;
function capitalize(str) {
    return str.charAt(0).toUpperCase() + str.slice(1);
}
exports.capitalize = capitalize;
function clone(obj) {
    let result = obj;
    var type = {}.toString.call(obj).slice(8, -1);
    if (type == "Set") {
        return new Set([...obj].map((value) => clone(value)));
    }
    if (type == "Map") {
        return new Map([...obj].map((kv) => [clone(kv[0]), clone(kv[1])]));
    }
    if (type == "Date") {
        return new Date(obj.getTime());
    }
    if (type == "RegExp") {
        return RegExp(obj.source, getRegExpFlags(obj));
    }
    if (type == "Array" || type == "Object") {
        result = Array.isArray(obj) ? [] : {};
        for (var key in obj) {
            // include prototype properties
            result[key] = clone(obj[key]);
        }
    }
    // primitives and non-supported objects (e.g. functions) land here
    return result;
}
exports.clone = clone;
function getRegExpFlags(regExp) {
    if (typeof regExp.source.flags == "string") {
        return regExp.source.flags;
    }
    else {
        var flags = [];
        regExp.global && flags.push("g");
        regExp.ignoreCase && flags.push("i");
        regExp.multiline && flags.push("m");
        regExp.sticky && flags.push("y");
        regExp.unicode && flags.push("u");
        return flags.join("");
    }
}
